<html>
<head>
    <title>Create Transaction</title>
	<style>
	table, td{
		border-collapse: collapse;
		border: 1px solid;
	}
	</style>
	<script src="head.js"></script>
	<script>
	let walIdx = 0;
	let cluster = 0;
	let role = 0;
	
	function roleToPw(role){
		let p = role-3000;
		let pw = p + " " + p + " " + p + " " + p + " " + p;
		return pw;
	}
	function seePw(inout){
		var x = document.getElementById("pw");
		if (inout == 1) {
			x.type = "text";
		} else {
			x.type = "password";
		}
	}
	
	async function loadJson(role, walIdx){	//disIdx
		let rsp01 = await fetch('http://35.161.83.70:' + role + '/operator/wallets/') ;
		let jR01 = await rsp01.json();
		//console.log(jR01);
		
		
		let txTable = "<table>";
		txTable += "<tr><td>Role</td><td>http://35.161.83.70:<select id='roleSel' onchange='loadJson(this.value, 0)'>";
		for(let i = 0; i < 3 ; i++){
			txTable += "<option value='" + (cluster*1+i) + "'>" + (cluster*1+i) + "</option>";
		}
		txTable += "</select></td></tr>";
		
		// Select a Wallet
		txTable += "<tr><td>Wallet</td><td><select id='walletSel' onchange='loadJson(" + role + ",this.value)'>";
		jR01.forEach(function(wallet, index){
			txTable += "<option value='" + index + "'>" + wallet.id + "</option>";
		})
		txTable += "</select></td></tr>";
		
		// Password
		txTable += "<tr><td>Password</td><td><input type='password' id='pw' value='" + roleToPw(role) + "' onfocusin='seePw(1)' onfocusout='seePw(0)'></td></tr>";
		
		// Tx Address
		txTable += "<tr><td>Tx Addr</td><td><select id='txAddrSel' onchange='loadJson02(role, this.value)'>";
		jR01[walIdx].addresses.forEach(function(addr, index){
			txTable += "<option value='" + addr + "'>" + addr + "</option>";
		})
		txTable += "</select><br><font size='2'><i><span id='dupAddr'></span></i></font></td></tr>";	//&emsp;<button onclick='copyAddr()'>Copy</button>
		txTable += "<tr><td>Addr Balance</td><td><span id='addrBalance'/></td></tr>";
		txTable += "<tr><td>Rcv Addr</td><td><input type='text' id='rcvAddr'></td></tr>";
		txTable += "<tr><td>Amount</td><td><input type='text' id='amount'></td></tr>";
		txTable += "<tr><td>Submit</td><td><button onclick='postData(" + role + ", \"" + jR01[walIdx].id + "\")'>Submit</button><span id='submitResult'></span></td></tr></table>";
		
		document.getElementById("showTx").innerHTML = txTable;
		
		//dropdown pre-select the current info
		document.getElementById("walletSel").getElementsByTagName('option')[walIdx].selected = "selected";
		document.getElementById("roleSel").getElementsByTagName('option')[role - cluster].selected = "selected";
		loadJson02(role, jR01[walIdx].addresses[0]);
	}
	//loadJson(role, walIdx);
	
	async function loadJson02(role, addrId){
		document.getElementById("addrBalance").innerHTML = 0;
		document.getElementById("dupAddr").innerHTML = addrId;
		let rsp02 = await fetch('http://35.161.83.70:' + role + '/operator/'+ addrId +'/balance/');
		let jR02 = await rsp02.json();
		//console.log('tx addr role' + role);
		//console.log(jR02);
		if(!isNaN(jR02.balance)){
			document.getElementById("addrBalance").innerHTML = jR02.balance;
		}
	};
	
	//function to set post request
	async function postData(role, walId) {
		document.getElementById("submitResult").innerHTML = "&emsp;<img src='https://c.tenor.com/I6kN-6X7nhAAAAAj/loading-buffering.gif' height='30'/>";
		// Default options are marked with *
		const response = await fetch('http://35.161.83.70:' + role + '/operator/wallets/' + walId + '/transactions', {
			method: 'POST', // *GET, POST, PUT, DELETE, etc.
			//mode: 'cors', // no-cors, *cors, same-origin
			cache: 'no-cache', // *default, no-cache, reload, force-cache, only-if-cached
			//credentials: 'same-origin', // include, *same-origin, omit
			headers: {
				'Content-Type': 'application/json',
				'walletId': walId,
				'Password': document.getElementById('pw').value
				// 'Content-Type': 'application/x-www-form-urlencoded',
			},
			redirect: 'follow', // manual, *follow, error
			referrerPolicy: 'no-referrer', // no-referrer, *no-referrer-when-downgrade, origin, origin-when-cross-origin, same-origin, strict-origin, strict-origin-when-cross-origin, unsafe-url
			body: JSON.stringify({
				  "fromAddress": document.getElementById('txAddrSel').value,
				  "toAddress": document.getElementById('rcvAddr').value,
				  "amount": document.getElementById('amount').value,
				  "changeAddress": document.getElementById('txAddrSel').value
				}) // body data type must match "Content-Type" header
		});
		let responseJson = await response.json();
		console.log(responseJson);
		let txID = responseJson.id ;
		let checkTxIdConfirmationLink = 'http://35.161.83.70:' + role + "/node/transactions/" + txID + "/confirmations" ;
		let linkDisplayString = "<a href='" +checkTxIdConfirmationLink+ "' target='_blank'>" + txID + "</a>" ;
		document.getElementById("submitResult").innerHTML = " Transaction :" + "<br> <br>" + linkDisplayString;
		//return response.json(); // parses JSON response into native JavaScript objects
	}
	
	function copyAddr(){
		var copyText = document.getElementById("txAddrSel").value;
		navigator.clipboard.writeText(copyText);
	}

	</script>
</head>
<body onload="printPageHeader()">
	<div id="jsHeader">
		Prepare / Create Transactions
	</div>
	
	<!-- Structure example
	<table id="blocks">
	<tr><td>Role</td><td>3001</td></tr>
	<tr><td>Wallet</td><td>(Wallet dropdown)</td></tr>
	<tr><td>Password</td><td>(Wallet Password, can be hidden or prefilled?)</td></tr>
	<tr><td>Tx Addr</td><td>(Addr dropdown)</td></tr>
	<tr><td>Addr Unspent</td><td>(display value)</td></tr>
	<tr><td>Rcv Addr</td><td>(input field)</td></tr>
	<tr><td>Amount</td><td>(input field)</td></tr>
	<tr><td>Send</td><td>(Send button)</td></tr>
	</table>
	-->
	<br>
	<div id="showTx">
		table showing here...
	</div>
</body>
</html>